Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 7567)
@@ -1012,8 +1864,8 @@
      !! 
      !!        2. Write heat transports in "heat_transport"
-     !!           Unit: Peta W : area * Velocity * T * rhop * Cp * 1.e-15
+     !!           Unit: Peta W : area * Velocity * T * rhau * Cp / 1.e15
      !! 
      !!        3. Write salt transports in "salt_transport"
-     !!           Unit: 10^9 Kg/m^2/s : area * Velocity * S * rhop * 1.e-9 
+     !!           Unit: 10^9 g m^3 / s : area * Velocity * S / 1.e6
      !!
      !!------------------------------------------------------------- 
@@ -1031,5 +1883,5 @@
      REAL(wp), POINTER, DIMENSION(:):: zsumclasses ! 1D workspace 
      !!------------------------------------------------------------- 
-     CALL wrk_alloc(nb_type_class , zsumclasses )  
+     CALL wrk_alloc(nb_type , zsumclasses )  
 
      zsumclasses(:)=0._wp
@@ -1042,5 +1894,5 @@
         zbnd1   = 0._wp
         zbnd2   = 0._wp
-        zsumclasses(1:nb_type_class)=zsumclasses(1:nb_type_class)+sec%transport(1:nb_type_class,jclass)
+        zsumclasses(1:nb_type)=zsumclasses(1:nb_type)+sec%transport(1:nb_type,jclass)
 
    
@@ -1090,13 +1942,13 @@
 
            !write heat transport per class:
-           WRITE(numdct_heat,119) ndastp,kt,ksec,sec%name,zslope,  &
+           WRITE(numdct_temp,119) ndastp,kt,ksec,sec%name,zslope,  &
                               jclass,classe,zbnd1,zbnd2,&
-                              sec%transport(3,jclass)*1.e-15,sec%transport(4,jclass)*1.e-15, &
-                              ( sec%transport(3,jclass)+sec%transport(4,jclass) )*1.e-15
+                              sec%transport(7,jclass)*1000._wp*rcp/1.e15,sec%transport(8,jclass)*1000._wp*rcp/1.e15, &
+                              ( sec%transport(7,jclass)+sec%transport(8,jclass) )*1000._wp*rcp/1.e15
            !write salt transport per class
-           WRITE(numdct_salt,119) ndastp,kt,ksec,sec%name,zslope,  &
+           WRITE(numdct_sal ,119) ndastp,kt,ksec,sec%name,zslope,  &
                               jclass,classe,zbnd1,zbnd2,&
-                              sec%transport(5,jclass)*1.e-9,sec%transport(6,jclass)*1.e-9,&
-                              (sec%transport(5,jclass)+sec%transport(6,jclass))*1.e-9
+                              sec%transport(9,jclass)*1000._wp/1.e9,sec%transport(10,jclass)*1000._wp/1.e9,&
+                              (sec%transport(9,jclass)+sec%transport(10,jclass))*1000._wp/1.e9
         ENDIF
 
@@ -1115,13 +1967,13 @@
 
         !write total heat transport
-        WRITE(numdct_heat,119) ndastp,kt,ksec,sec%name,zslope, &
+        WRITE(numdct_temp,119) ndastp,kt,ksec,sec%name,zslope, &
                            jclass,"total",zbnd1,zbnd2,&
-                           zsumclasses(3)*1.e-15,zsumclasses(4)*1.e-15,&
-                           (zsumclasses(3)+zsumclasses(4) )*1.e-15
+                           zsumclasses(7)* 1000._wp*rcp/1.e15,zsumclasses(8)* 1000._wp*rcp/1.e15,&
+                           (zsumclasses(7)+zsumclasses(8) )* 1000._wp*rcp/1.e15
         !write total salt transport
-        WRITE(numdct_salt,119) ndastp,kt,ksec,sec%name,zslope, &
+        WRITE(numdct_sal ,119) ndastp,kt,ksec,sec%name,zslope, &
                            jclass,"total",zbnd1,zbnd2,&
-                           zsumclasses(5)*1.e-9,zsumclasses(6)*1.e-9,&
-                           (zsumclasses(5)+zsumclasses(6))*1.e-9
+                           zsumclasses(9)*1000._wp/1.e9,zsumclasses(10)*1000._wp/1.e9,&
+                           (zsumclasses(9)+zsumclasses(10))*1000._wp/1.e9
      ENDIF
 
@@ -1131,11 +1983,11 @@
         WRITE(numdct_vol,118) ndastp,kt,ksec,sec%name,zslope,&
                               jclass,"ice_vol",zbnd1,zbnd2,&
-                              sec%transport(7,1),sec%transport(8,1),&
-                              sec%transport(7,1)+sec%transport(8,1)
+                              sec%transport(11,1),sec%transport(12,1),&
+                              sec%transport(11,1)+sec%transport(12,1)
         !write total ice surface transport
         WRITE(numdct_vol,118) ndastp,kt,ksec,sec%name,zslope,&
                               jclass,"ice_surf",zbnd1,zbnd2,&
-                              sec%transport(9,1),sec%transport(10,1), &
-                              sec%transport(9,1)+sec%transport(10,1) 
+                              sec%transport(13,1),sec%transport(14,1), &
+                              sec%transport(13,1)+sec%transport(14,1) 
      ENDIF
                                               
@@ -1143,5 +1995,5 @@
 119 FORMAT(I8,1X,I8,1X,I4,1X,A30,1X,f9.2,1X,I4,3X,A8,1X,2F12.4,5X,3E15.6)
 
-     CALL wrk_dealloc(nb_type_class , zsumclasses )  
+     CALL wrk_dealloc(nb_type , zsumclasses )  
   END SUBROUTINE dia_dct_wri
 
@@ -1149,5 +2001,5 @@
   !!----------------------------------------------------------------------
   !!
-  !!   Purpose: compute temperature/salinity/density at U-point or V-point
+  !!   Purpose: compute Temperature/Salinity/density at U-point or V-point
   !!   --------
   !!
@@ -1158,7 +2010,7 @@
   !! 
   !!
-  !!    |    I          |    I+1           |    Z=temperature/salinity/density at U-poinT
+  !!    |    I          |    I+1           |    Z=Temperature/Salinity/density at U-poinT
   !!    |               |                  |
-  !!  ----------------------------------------  1. Veritcal interpolation: compute zbis
+  !!  ----------------------------------------  1. Veritcale interpolation: compute zbis
   !!    |               |                  |       interpolation between ptab(I,J,K) and ptab(I,J,K+1)
   !!    |               |                  |       zbis = 
@@ -1245,10 +2097,11 @@
      zdep2 = fsdept(ii2,ij2,kk) - zdepu
 
-     ! weights
+     !weights
      zwgt1 = SQRT( ( 0.5 * zet1 ) * ( 0.5 * zet1 ) + ( zdep1 * zdep1 ) )
      zwgt2 = SQRT( ( 0.5 * zet2 ) * ( 0.5 * zet2 ) + ( zdep2 * zdep2 ) )
   
      ! result
-     interp = zmsk * ( zwgt2 *  ptab(ii1,ij1,kk) + zwgt1 *  ptab(ii1,ij1,kk) ) / ( zwgt2 + zwgt1 )   
+     !JT interp = zmsk * ( zwgt2 *  ptab(ii1,ij1,kk) + zwgt1 *  ptab(ii1,ij1,kk) ) / ( zwgt2 + zwgt1 )   
+     interp = umask(ii1,ij1,kk) * ( zwgt2 *  ptab(ii1,ij1,kk) + zwgt1 *  ptab(ii1,ij1,kk) ) / ( zwgt2 + zwgt1 )   
 
 
@@ -1275,14 +2128,17 @@
            zbis = ptab(ii2,ij2,kk) + zwgt1 * ( ptab(ii2,ij2,kk-1) - ptab(ii2,ij2,kk) ) 
            ! result
-            interp = zmsk * ( zet2 * ptab(ii1,ij1,kk) + zet1 * zbis )/( zet1 + zet2 )
+            !JT interp = zmsk * ( zet2 * ptab(ii1,ij1,kk) + zet1 * zbis )/( zet1 + zet2 )
+            interp = umask(ii1,ij1,kk) * ( zet2 * ptab(ii1,ij1,kk) + zet1 * zbis )/( zet1 + zet2 )
         ELSE
            ! zbis
            zbis = ptab(ii1,ij1,kk) + zwgt2 * ( ptab(ii1,ij1,kk-1) - ptab(ii1,ij2,kk) )
            ! result
-           interp = zmsk * ( zet2 * zbis + zet1 * ptab(ii2,ij2,kk) )/( zet1 + zet2 )
+           !JT interp = zmsk * ( zet2 * zbis + zet1 * ptab(ii2,ij2,kk) )/( zet1 + zet2 )
+           interp = umask(ii1,ij1,kk) * ( zet2 * zbis + zet1 * ptab(ii2,ij2,kk) )/( zet1 + zet2 )
         ENDIF    
 
      ELSE
-        interp = zmsk * (  zet2 * ptab(ii1,ij1,kk) + zet1 * ptab(ii2,ij2,kk) )/( zet1 + zet2 )
+        !JT interp = zmsk * (  zet2 * ptab(ii1,ij1,kk) + zet1 * ptab(ii2,ij2,kk) )/( zet1 + zet2 )
+        interp = umask(ii1,ij1,kk) * (  zet2 * ptab(ii1,ij1,kk) + zet1 * ptab(ii2,ij2,kk) )/( zet1 + zet2 )
      ENDIF
 
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diainsitutem.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diainsitutem.F90	(revision 7567)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diainsitutem.F90	(revision 7567)
@@ -0,0 +1,124 @@
+MODULE diainsitutem
+   !!======================================================================
+   !!                       ***  MODULE  diaharm  ***
+   !! Harmonic analysis of tidal constituents
+   !!======================================================================
+   !! Initial version: D. Acreman June 2006 Original Code
+   !! History :  3.6  !  2014  (E O'Dea) for 3.6 25hour mean output
+   !!----------------------------------------------------------------------
+
+  USE dom_oce  ! ocean space and time domain
+  USE oce,            ONLY: tsn
+  USE par_oce,        ONLY: jpi, jpj, jpk, jpkm1
+  USE lbclnk,         ONLY: lbc_lnk
+  USE lib_mpp         ! MPP library
+
+  IMPLICIT NONE
+  PRIVATE
+
+  PUBLIC theta2t
+
+  !! * Accessibility
+  PUBLIC insitu_tem_alloc          ! routines called by step.F90
+
+  REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:,:) :: rinsitu_t
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+
+CONTAINS
+
+   REAL FUNCTION insitu_tem_alloc()
+      !!----------------------------------------------------------------------
+      INTEGER, DIMENSION(2) :: ierr
+      !!----------------------------------------------------------------------
+      !
+      ierr = 0
+      !
+      ALLOCATE( rinsitu_t(jpi,jpj,jpk), STAT=ierr(1) )
+         !
+      insitu_tem_alloc = MAXVAL(ierr)
+      IF( lk_mpp )   CALL mpp_sum( insitu_tem_alloc )
+      !
+  END FUNCTION insitu_tem_alloc
+
+!-----------------------------------------------------------------------------------
+!
+! Calculate the insitu temperature by integrating the adiabatic lapse rate from zero 
+! to pressure at depth of tracer level. Based on UM subroutine POTTEM and function ATG
+!
+! Initial version: D. Acreman June 2006
+!
+!-----------------------------------------------------------------------------------
+
+  SUBROUTINE theta2t()
+
+    INTEGER, PARAMETER :: inum_steps=10                ! number of steps in integration
+    INTEGER            :: jstep                        ! iteration counter
+    INTEGER            :: ji, jj, jk                  ! loop indices
+    REAL(wp), DIMENSION(jpi,jpj,jpk) :: zP            ! pressure (decibars)
+    REAL(wp), DIMENSION(jpi,jpj,jpk) :: zT            ! temperature at pressure p
+    REAL(wp), DIMENSION(jpi,jpj,jpk) :: zTB           ! temperature at p-dp
+    REAL(wp), DIMENSION(jpi,jpj,jpk) :: zTA           ! temperature at p+dp
+    REAL(wp), DIMENSION(jpi,jpj,jpk) :: zDP           ! pressure step
+    REAL(wp), DIMENSION(jpi,jpj,jpk) :: zSS           ! salinity(PSU) - 35.0
+    REAL(wp), DIMENSION(jpi,jpj,jpk) :: zLAPSE        ! adiabatic lapse rate
+
+!CDIR IEXPAND (ATG)
+
+! Set the pressure interval for the integration. The integration is carried out from 
+! zero (pressure at the surface) to the pressure at the depth of the tracer point. The
+! pressure in decibars is represented by the depth in metres. Pressures are "Oceanographic"
+! pressures equal to absolute pressure minus one atmosphere
+     zDP(:,:,:) = 0.0
+     DO jk = 1, jpkm1
+        DO jj = 1, jpj
+           DO ji = 1, jpi
+              ! These loops expanded for case where fsdept may be 1D
+              zDP(ji,jj,jk) = fsdept(ji,jj,jk) / real(inum_steps)
+           END DO
+        END DO
+     END DO
+
+! Salinity at each point
+     zSS(:,:,:)      = tsn(:,:,:,jp_sal) - 35.0 
+
+! Set initial values of temperature and pressure. zT is the temperature at pressure zP, 
+! zTB is the temperature at pressure zP-zdP and zTA is the temperature at pressure zP+zdP
+     zT(:,:,:)  = tsn(:,:,:,jp_tem)
+     zP(:,:,:)  = 0.0         ! Pressure at surface
+     CALL ATG(zP, zT, zSS, zLAPSE)
+     zTB(:,:,:) = zT(:,:,:)  - zLAPSE(:,:,:) * zDP(:,:,:)
+
+     interation: DO jstep=1, inum_steps
+        ! Calculate lapse rate (dT/dP) and hence TA
+        CALL ATG(zP, zT, zSS, zLAPSE)
+        zTA(:,:,:) = zTB(:,:,:) + 2.0 * zLAPSE(:,:,:) * zDP(:,:,:)
+        ! Have calculated TB, T and TA for this pressure, now advance solution by dP
+        zP(:,:,:)  = zP(:,:,:)  + zDP
+        zTB(:,:,:) = zT(:,:,:)
+        zT(:,:,:)  = zTA(:,:,:)
+
+     END DO interation
+
+     rinsitu_t(:,:,:) = zT(:,:,:) * tmask(:,:,:)
+     CALL lbc_lnk( rinsitu_t,  'T', 1.0)
+
+   END SUBROUTINE theta2t
+
+   SUBROUTINE ATG(P,T,DS,zLAPSE)
+
+     REAL, INTENT(IN   ) :: P(jpi,jpj,jpk)        ! PRESSURE (DECIBARS)
+     REAL, INTENT(IN   ) :: T(jpi,jpj,jpk)        ! TEMPERATURE (DEG C)
+     REAL, INTENT(IN   ) :: DS(jpi,jpj,jpk)       ! SALINITY (PSU) -35.0
+     REAL, INTENT(  OUT) :: zLAPSE(jpi,jpj,jpk)   ! LAPSE RATE
+
+       zLAPSE = ((( -2.1687E-16*T+1.8676E-14)*T-4.6206E-13)*P &
+           + ((2.7759E-12*T-1.1351E-10)*DS+((-5.4481E-14*T    &
+           + 8.733E-12)*T-6.7795E-10)*T+1.8741E-8))*P         &
+           + (-4.2393E-8*T+1.8932E-6)*DS                      &
+           + ((6.6228E-10*T-6.836E-8)*T+8.5258E-6)*T+3.5803E-5 
+
+   END SUBROUTINE ATG
+
+END MODULE diainsitutem
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diapea.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diapea.F90	(revision 7567)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/DIA/diapea.F90	(revision 7567)
@@ -0,0 +1,267 @@
+MODULE diapea
+   !!======================================================================
+   !!                       ***  MODULE  diapea  ***
+   !! Potential Energy Anomaly 
+   !!======================================================================
+   !! History :  3.6  !  12/2016  (J Tinker)  Original code
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers variables
+   USE dom_oce         ! ocean space and time domain
+   USE in_out_manager  ! I/O units
+   USE iom             ! I/0 library
+   USE wrk_nemo        ! working arrays
+   USE eosbn2          ! Equation of state - in situ and potential density
+   USE phycst          ! physical constant
+
+   IMPLICIT NONE
+   PRIVATE 
+   
+   PUBLIC   dia_pea_init            ! routine called by nemogcm.F90
+   PUBLIC   dia_pea                 ! routine called by diawri.F90
+   REAL(wp), PUBLIC, SAVE, ALLOCATABLE,   DIMENSION(:,:)  ::   pea,peat,peas   
+   REAL(wp), SAVE, ALLOCATABLE,   DIMENSION(:,:,:)  ::   wgt_co_mat   ! Weighting array for proportion of grid shallower than cut off depth
+   REAL(wp), SAVE, ALLOCATABLE,   DIMENSION(:,:) ::   t_zmean, s_zmean  !Depth mean temperature and salinity: 2d fields
+   REAL(wp), SAVE, ALLOCATABLE,   DIMENSION(:,:,:) ::   t_zmean_mat, s_zmean_mat  !Depth mean temperature and salinity: 3d fields
+   REAL(wp) ::   zcutoff
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.6 , NEMO Consortium (2014)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE dia_pea_init
+      ! Local variables
+      INTEGER :: ji,jj,jk  ! Dummy loop indices
+      REAL(wp) :: sumz,tmpsumz
+      INTEGER  :: ierr                ! error integer for IOM_get
+      
+      zcutoff = 200.!200m
+      
+   ALLOCATE( pea(jpi,jpj),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate pea array' )
+   
+   ALLOCATE( peat(jpi,jpj),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate peat array' )
+   
+   ALLOCATE( peas(jpi,jpj),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate peas array' )   
+      
+   ALLOCATE( t_zmean_mat(jpi,jpj,jpk),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate t_zmean_mat array' )
+   
+   ALLOCATE( s_zmean_mat(jpi,jpj,jpk),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate s_zmean_mat array' )
+   
+   ALLOCATE( t_zmean(jpi,jpj),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate t_zmean array' )
+   
+   ALLOCATE( s_zmean(jpi,jpj),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate s_zmean array' )
+   
+   ALLOCATE( wgt_co_mat(jpi,jpj,jpk),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate wgt_co_mat array' )
+          
+    ! create wgt_co_mat mat, with the proportion of the grid (gdept_0) below cut off (200m)
+    
+    DO jj = 1,jpj
+        DO ji = 1,jpi
+            IF ( tmask(ji,jj,1) == 1.0_wp ) THEN
+              sumz = 0.
+              DO jk = 1,jpk
+                IF ( tmask(ji,jj,jk) == 1.0_wp ) THEN
+                  tmpsumz = sumz + e3t_n(ji,jj,jk)
+                  IF (sumz .ge. zcutoff) THEN
+                    ! Already too deep
+                    wgt_co_mat(ji,jj,jk) = 0.
+                  ELSE IF (tmpsumz .le. zcutoff) THEN
+                    ! Too shallow
+                    wgt_co_mat(ji,jj,jk) = 1.
+                  ELSE
+                    !proprotion of grid box above cut off depth
+                    wgt_co_mat(ji,jj,jk) = (zcutoff-Sumz)/e3t_n(ji,jj,jk)
+                  END IF
+                  sumz = tmpsumz
+                endif
+              END DO
+              
+            ELSE
+              !if land, set to 0.
+              DO jk = 1,jpk
+                wgt_co_mat(ji,jj,jk) = 0.
+              END DO
+                
+            ENDIF
+        END DO
+   END DO
+   
+
+   END SUBROUTINE dia_pea_init
+   
+
+   SUBROUTINE dia_pea(kt)
+   INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
+    
+   INTEGER :: ji,jj,jk,ierr  ! Dummy loop indices
+   REAL(wp) :: tmpdenom, tmpnum, maxz
+   !rau0
+   
+   REAL(wp), ALLOCATABLE,   DIMENSION(:,:,:,:) ::   ts_pea_mat,ts_pea_mat_TS_mean,ts_pea_mat_S_mean
+   REAL(wp), ALLOCATABLE,   DIMENSION(:,:,:) ::   tmp_pea_rho,tmp_pea_TS_mean_rho,tmp_pea_S_mean_rho
+   REAL(wp) ::   int_y_pea,int_y_pea_t
+   
+   
+      
+   ALLOCATE( ts_pea_mat(jpi,jpj,jpk,2),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate ts_pea_mat array' )    
+   ALLOCATE( ts_pea_mat_TS_mean(jpi,jpj,jpk,2),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate ts_pea_mat_TS_mean array' )   
+   ALLOCATE( ts_pea_mat_S_mean(jpi,jpj,jpk,2),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate ts_pea_mat_S_mean array' )
+   ALLOCATE( tmp_pea_rho(jpi,jpj,jpk),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate tmp_pea_rho array' )
+   ALLOCATE( tmp_pea_TS_mean_rho(jpi,jpj,jpk),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate tmp_pea_TS_mean_rho array' )
+   ALLOCATE( tmp_pea_S_mean_rho(jpi,jpj,jpk),  STAT= ierr )
+   IF( ierr /= 0 )   CALL ctl_stop( 'dia_pea_init: failed to allocate tmp_pea_S_mean_rho array' )
+
+    pea(:,:)=0.0d0
+    peaT(:,:)=0.0d0
+    peaS(:,:)=0.0d0
+    
+    
+    
+    !calculate the depth mean temperature and salinity of the upper 200m. Save this into a 3d array. Set the value where tmask=0 to be tsn. 
+    
+     DO jj = 1,jpj
+         DO ji = 1,jpi
+            IF ( tmask(ji,jj,1) == 1.0_wp ) THEN  ! if a sea point. 
+            
+             !Depth mean temperature
+             tmpdenom = 0.
+             tmpnum = 0.
+             DO jk = 1,jpk
+                IF ( tmask(ji,jj,jk) == 1.0_wp ) THEN
+                  tmpnum = tmpnum + (wgt_co_mat(ji,jj,jk)*e3t_n(ji,jj,jk)*tsn(ji,jj,jk,jp_tem))
+                  tmpdenom = tmpdenom + (wgt_co_mat(ji,jj,jk)*e3t_n(ji,jj,jk))
+                endif
+             END DO
+             t_zmean(ji,jj) = tmpnum/tmpdenom
+             
+             !Depth mean salinity
+             tmpdenom = 0.
+             tmpnum = 0.
+             DO jk = 1,jpk
+                IF ( tmask(ji,jj,jk) == 1.0_wp ) THEN
+                  tmpnum     = tmpnum + (wgt_co_mat(ji,jj,jk)*e3t_n(ji,jj,jk)*tsn(ji,jj,jk,jp_sal))
+                  tmpdenom = tmpdenom + (wgt_co_mat(ji,jj,jk)*e3t_n(ji,jj,jk))
+                endif
+             END DO
+             s_zmean(ji,jj) = tmpnum/tmpdenom
+             
+             !save into a 3d grid
+             DO jk = 1,jpk
+               IF ( tmask(ji,jj,jk) == 1.0_wp ) THEN
+                 t_zmean_mat(ji,jj,jk) = t_zmean(ji,jj)
+                 s_zmean_mat(ji,jj,jk) = s_zmean(ji,jj)
+               else
+                 t_zmean_mat(ji,jj,jk) = tsn(ji,jj,jk,jp_tem)
+                 s_zmean_mat(ji,jj,jk) = tsn(ji,jj,jk,jp_sal)
+               endif
+             END DO
+            else
+              t_zmean(ji,jj) = tsn(ji,jj,1,jp_tem)
+              s_zmean(ji,jj) = tsn(ji,jj,1,jp_sal)
+              DO jk = 1,jpk
+                t_zmean_mat(ji,jj,jk) = tsn(ji,jj,jk,jp_tem)
+                s_zmean_mat(ji,jj,jk) = tsn(ji,jj,jk,jp_sal)
+              END DO
+            endif
+            
+         END DO
+     END DO
+      
+   !Calculate the density from the depth varying, and depth average temperature and salinity
+   !-----------------------------
+   !-----------------------------
+   
+   ts_pea_mat(:,:,:,:) = tsn(:,:,:,:)
+   
+   ts_pea_mat_TS_mean(:,:,:,1) = t_zmean_mat(:,:,:)
+   ts_pea_mat_TS_mean(:,:,:,2) = s_zmean_mat(:,:,:)
+   
+   ts_pea_mat_S_mean(:,:,:,1) = t_zmean_mat(:,:,:)
+   ts_pea_mat_S_mean(:,:,:,2) = tsn(:,:,:,jp_sal)
+   
+   CALL eos ( ts_pea_mat,         tmp_pea_rho,         gdept_n(:,:,:) )
+   CALL eos ( ts_pea_mat_TS_mean, tmp_pea_TS_mean_rho, gdept_n(:,:,:) )
+   CALL eos ( ts_pea_mat_S_mean,  tmp_pea_S_mean_rho,  gdept_n(:,:,:) )
+   tmp_pea_rho = (tmp_pea_rho * rau0) + rau0
+   tmp_pea_TS_mean_rho = (tmp_pea_TS_mean_rho * rau0) + rau0
+   tmp_pea_S_mean_rho = (tmp_pea_S_mean_rho * rau0) + rau0
+   
+   
+   ! to test the density calculation
+   !CALL iom_put( "tmp_pea_rho" , tmp_pea_rho )                 ! pea
+   !CALL iom_put( "tmp_pea_TS_mean_rho" , tmp_pea_TS_mean_rho )                 ! pea
+   
+   
+   ! Caluclation of the PEA.
+    DO jj = 1,jpj
+      DO ji = 1,jpi
+        pea(ji,jj) = 0.
+        peat(ji,jj) = 0.
+        peas(ji,jj) = 0.
+        maxz = 0.
+        int_y_pea = 0.
+        int_y_pea_t = 0.
+        IF ( tmask(ji,jj,1) == 1.0_wp ) THEN ! for sea points
+        
+          ! the depth integrated calculation is summed up over the depths, and then divided by the depth
+          DO jk = 1,jpk
+            !for each level...
+            
+            IF ( tmask(ji,jj,jk) == 1.0_wp ) THEN ! if above the sea bed...
+              int_y_pea =   -((tmp_pea_TS_mean_rho(ji,jj,jk)) - (tmp_pea_rho(ji,jj,jk)))*9.81*gdept_n(ji,jj,jk)*wgt_co_mat(ji,jj,jk)*e3t_n(ji,jj,jk)
+              int_y_pea_t = -((tmp_pea_S_mean_rho(ji,jj,jk))  - (tmp_pea_rho(ji,jj,jk)))*9.81*gdept_n(ji,jj,jk)*wgt_co_mat(ji,jj,jk)*e3t_n(ji,jj,jk)
+            else
+              int_y_pea = 0.
+              int_y_pea_t = 0.
+            endif
+            
+            ! check that the sum is not NaN. 
+            if ( int_y_pea .ne.  int_y_pea    ) int_y_pea = 0.
+            if ( int_y_pea_t .ne. int_y_pea_t )  int_y_pea_t = 0.
+            !if ( (int_y_pea*int_y_pea    ) .gt. 1.0e6 ) int_y_pea = 0.
+            !if ( (int_y_pea_t*int_y_pea_t) .gt. 1.0e6 ) int_y_pea_t = 0.
+            
+            pea(ji,jj) =  pea(ji,jj) + int_y_pea
+            peat(ji,jj) =  peat(ji,jj) + int_y_pea_t
+            maxz = maxz + (e3t_n(ji,jj,jk)*wgt_co_mat(ji,jj,jk))
+          enddo
+            
+            
+          !divide by the depth
+          pea(ji,jj) = pea(ji,jj)/maxz
+          peat(ji,jj) = peat(ji,jj)/maxz
+          peas(ji,jj) = pea(ji,jj) - peat(ji,jj)
+            
+            
+          else
+            pea(ji,jj) = 0.
+            peat(ji,jj) = 0.
+            peas(ji,jj) = 0.
+          endif
+       enddo
+    enddo
+!    
+     CALL iom_put( "pea" , pea )                 ! pea
+     CALL iom_put( "peat" , peat )               ! pea
+     CALL iom_put( "peas" , peas )               ! pea
+           
+
+    DEALLOCATE(ts_pea_mat,ts_pea_mat_TS_mean,ts_pea_mat_S_mean,tmp_pea_rho,tmp_pea_TS_mean_rho,tmp_pea_S_mean_rho)
+   
+   END SUBROUTINE dia_pea
+
+END MODULE diapea
